<?php

namespace Slovocast\Controller;

use Slovocast\Controller\Controller;
use Slovocast\Infrastructure\Api\Database\DatabaseHandlerInterface;
use Psr\Http\Message\ResponseInterface as Response;

class HealthCheck extends Controller
{
    public function __construct(
        protected DatabaseHandlerInterface $database 
    ) { }

    public function handle(): Response
    {
        $statement = $this->database->getConnection()->query('SELECT 1');
        $results = $statement->fetchAll();

        return $this->json([
            'http' => true,
            'database' => (bool) count($results),
        ]);
    }
}
